/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package memegene;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JFrame;

/**Listener del evento de presionar el botón "Go", para comenzar la ejecución de los algoritmos
 * Genético y Memético.
 *
 * @author Mauricio Alarcón M.
 * @author Felipe Urra A.
 */
public class ListenerGo implements ActionListener{

    /**
     * Referencia al marco principal de la aplicación
     */
    MemeGeneFrame padre;
    /**
     * Strings que determinan la funcion objetivo, y si se desea maximiizar o minimizar.
     */
    String funcion,maxMin;
    /**
     * Parametros que determinan el rango de la variable independiente
     */
    float desde,hasta;
    /**
     * Numero de dígitos sucesores a la coma flotante de la variable independiente
     */
    int precision;
    /**
     * booleano que es verdadero si la función es una función de minimización.
     */
    boolean maxMinBool;
    /**
     * Panel que contiene la referencia al gráfico.
     */
    GPanel panel;

    /**
     * Constructor
     * @param papi Marco de la aplicación
     * @param panel referencia al panel que contiene el gráfico
     */
    ListenerGo(MemeGeneFrame papi,GPanel panel){
        padre = papi;
        this.panel = panel;        
    }

    /**
     * Ejecuta los algoritmos
     * @param e evento de presinar el botón "Go" de la interfaz inicial de la aplicación
     */
    public void actionPerformed(ActionEvent e){

        padre.panelGrafico.resetearGrafico1();
        padre.panelGrafico.resetearGrafico2();
        funcion = (String)padre.funcionC.getText();
        desde = Float.parseFloat(padre.desdeC.getText());
        hasta = Float.parseFloat(padre.hastaC.getText());
        precision = Integer.parseInt(padre.precisionC.getText());
        maxMin = (String)padre.MaxMinC.getSelectedItem();
        if(maxMin.equals("Maximizacion")){
            maxMinBool = false;
        }else{
            maxMinBool = true;
        }

        GAFunction ga = new GAFunction(this.padre.poblacion ,this.padre.probMutac,maxMinBool,this.desde,this.hasta,precision,panel);
        ga.setFuncion(funcion);        
        MAFunction ma = new MAFunction(this.padre.poblacion ,this.padre.probMutac,maxMinBool,this.desde,this.hasta,precision,panel);
        ma.setFuncion(funcion);
        new Thread (new HebraGa(ga,this.padre.generaciones,padre.seleccion,this.padre.probVict,true)).run();
        new Thread (new HebraGa(ma,this.padre.generaciones,padre.seleccion,this.padre.probVict,false)).run();                
        
        
        
    }

}
